/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ControllerCommand.cs,v 1.4 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// R}hRg[pR}hۃNX
	/// </summary>
	public abstract class ControllerCommand : Zigumo.CommandObject.ICommand
	{
		/// <summary>
		/// R}hRg[ւ̎Q
		/// </summary>
		protected CommandController commandController;
		/// <summary>
		/// RlNV}l[Wւ̎Q
		/// </summary>
		protected ConnectionManager connectionManager;
		/// <summary>
		/// fւ̎Q
		/// </summary>
		protected ZigumoModel model;
		/// <summary>
		/// Xe[^Xo[XVfQ[g
		/// </summary>
		protected delegate void SetStatusBarDelegate(string text);

		/// <summary>
		/// Rg[R}h̃RXgN^
		/// </summary>
		public ControllerCommand() {
			commandController = CommandController.Controller;
			connectionManager = ConnectionManager.Manager;
			model = ZigumoModel.Model;
		}

		/// <summary>
		/// sp\bh
		/// </summary>
		public abstract void Execute();
	}

	/// <summary>
	/// nhVFCNsO
	/// </summary>
	public class HandShakeException : ApplicationException {
		public HandShakeException() {
		}
		public HandShakeException(string message) : base(message) {
		}
		public HandShakeException(string message, Exception inner) : base(message, inner) {
		}
	}
}
