/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ReceivePingCommand.cs,v 1.5 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;

using Zigumo.MessageObject;
using Zigumo.Model;
using Zigumo.Network;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// pingR}h
	/// </summary>
	public class ReceivePingCommand : Zigumo.CommandObject.ControllerCommand
	{
		/// <summary>
		/// ̃R}h𔭍sP2PRlNVւ̎Q
		/// </summary>
		private P2PConnection p2pConnection;
		/// <summary>
		/// MbZ[W
		/// </summary>
		private PingMessage ping;

		public ReceivePingCommand(P2PConnection p2pCon, PingMessage msg) {
			p2pConnection = p2pCon;
			ping = msg;
		}

		/// <summary>
		/// pingbZ[WMꍇ͎̕@ɂďs
		/// 1.MpingbZ[WƓIDLbVɂ邩ǂ
		/// 2.ꍇ́AbZ[WjB
		/// 3.Ȃꍇ́AԐMbZ[WƂāAping𑗂ĂT[ogpongԐM
		/// 4.pingbZ[W𑗂ĂT[ogȊOɒp
		/// </summary>
		public override void Execute() {
			if(ping.TTL == 0)//TTLɃ[Ȃ珈Ȃ
				return;

			//ɎMƂ̂郁bZ[WǂALbV`FbNMƂꍇpingLbVɓo^
			ConnectionManager.MessageCacheData msgCacheData = (ConnectionManager.MessageCacheData)connectionManager.PutCache(ping.MessageIDToGuid, new ConnectionManager.MessageCacheData(ping.Type, p2pConnection.ID));
			if(msgCacheData == null) {//xMĂȂꍇAbZ[WpongԂ

				//pong
				PongMessage pong = new PongMessage();
				pong.CreateHeader();
				pong.MessageID = ping.MessageID;//pongbZ[W͎MpingbZ[WƓIDgp
				pong.Port = model.PortNumber;
				pong.Address = model.IPAddress;
				pong.ThreadCount = 2002; //eXĝ߂̐
				pong.Status = model.ServentStatus;

				connectionManager.SendMessage(pong, p2pConnection, true);//MR}hs

				//TTLfNgTTL>0̏ꍇ̓bZ[W𒆌p
				ping.TTL--;
				ping.Hops++;
				if(ping.TTL > 0) {//TTL>0̏ꍇ̂݃bZ[W𒆌p
					//bZ[Wp
					connectionManager.SendMessage(ping, p2pConnection, false);//bZ[WMȊOɃu[hLXg
				}
			
			}
		}//end Execute
	}
}
