/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ReceiveQueryChatHitCommand.cs,v 1.4 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;

using Zigumo.MessageObject;
using Zigumo.Network;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// queryChatHitR}h
	/// </summary>
	public class ReceiveQueryChatHitCommand : Zigumo.CommandObject.ControllerCommand
	{
		/// <summary>
		/// ̃R}h𔭍sP2PRlNVւ̎Q
		/// </summary>
		private P2PConnection p2pConnection;
		/// <summary>
		/// MbZ[W
		/// </summary>
		private QueryChatHitMessage queryChatHit;

		public ReceiveQueryChatHitCommand(P2PConnection p2pCon, QueryChatHitMessage msg) {
			p2pConnection = p2pCon;
			queryChatHit = msg;
		}

		/// <summary>
		/// queryChatHitbZ[WMꍇ͎̕@ɂďs
		/// 1.MqueryChatHitbZ[W̃bZ[WIDƓqueryChatbZ[WLbVɓo^Ă邩
		/// 2.LbVɓo^ĂꍇAqueryChatbZ[W͎̔ŝǂ
		/// 3.̔ŝł΁AMqueryChatHitbZ[Ŵ͎̂̂߁AqueryChatHit̓e
		/// 4.̔ŝłȂ΁AqueryChatbZ[W𔭍sT[ogɑ΂jLXgŕԐM
		/// </summary>
		public override void Execute() {
			if(queryChatHit.TTL == 0)//TTLɃ[Ȃ珈Ȃ
				return;

			//connectionManager.AddServentInfo(new Servent(queryChatHit.Address, queryChatHit.Port, DateTime.Now.ToString());

			//ǂ̃RlNVɑ΂ĕԐM邩LbV`FbN
			ConnectionManager.MessageCacheData msgCacheData = connectionManager.GetCache(queryChatHit.MessageIDToGuid);
			if(msgCacheData != null) {//LbVɃbZ[WIDo^Ăꍇ̂ݏ
				if(msgCacheData.MessageType == (int)MessageType.QueryChat) {	//ALbVĂbZ[WqueryChatbZ[W̏ꍇ̂ݏ
					//ߋɃLbVĂqueryChatbZ[W̔ŝǂ
					//`FbNA̔ŝł΁AqueryChatHitbZ[WƂ
					//queryChatHitB̔ŝłȂ΁AqueryChatHitqueryChatsɃjLXg
					//őԂB
					if(msgCacheData.SelfFag) {
						//ւqueryChatHitbZ[W̏
					} else {
						//ȊÔւqueryChatHitbZ[W̏ꍇ
						//queryChatMɁAqueryChatHitbZ[WjLXgőԂB
						queryChatHit.TTL--;
						queryChatHit.Hops++;

						if(queryChatHit.TTL > 0) {//TTL>0̏ꍇ̂݃bZ[W𒆌p
							//bZ[Wp
							connectionManager.SendMessage(queryChatHit, msgCacheData.P2PConnectionID, true);//queryChat𑗐MĂT[ogɃjLXg
						}
					}
				}
			}//end if
		}//end Execute
	}//end class
}
