/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hogewo
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: PreferenceDialog.cs,v 1.5 2003/04/25 03:06:20 hoge-taicho Exp $
 * 
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Zigumo.DialogObject
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class PreferenceDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl mainTabControl;
		private System.Windows.Forms.TabPage operationTabPage;
		private System.Windows.Forms.GroupBox previewGroupBox;
		private System.Windows.Forms.GroupBox popupGroupBox;
		private System.Windows.Forms.GroupBox threadGroupBox;
		private System.Windows.Forms.TabPage connectionTabPage;
		private System.Windows.Forms.GroupBox writeProxyGroupBox;
		private System.Windows.Forms.TextBox writeProxyUATextBox;
		private System.Windows.Forms.TextBox writeProxyURLTextBox;
		private System.Windows.Forms.GroupBox readProxyGroupBox;
		private System.Windows.Forms.TextBox readProxyUATextBox;
		private System.Windows.Forms.TextBox readProxyURLTextBox;
		private System.Windows.Forms.GroupBox boardListGroupBox;
		private System.Windows.Forms.TextBox boardListTextBox;
		private System.Windows.Forms.TabPage otherTabPage;
		private System.Windows.Forms.RadioButton doubleClickRadioButton;
		private System.Windows.Forms.RadioButton clickRadioButton;
		private System.Windows.Forms.Label writeProxyUALabel;
		private System.Windows.Forms.Label writeProxyURLLabel;
		private System.Windows.Forms.Label readProxyUALabel;
		private System.Windows.Forms.Label readProxyURLLabel;
		private System.Windows.Forms.GroupBox threadUIGroupBox;
		private System.Windows.Forms.RadioButton perLineRadioButton;
		private System.Windows.Forms.RadioButton afterAllRadioButton;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Panel bottomPanel;
		private System.Windows.Forms.Splitter bottomSplitter;
		private System.Windows.Forms.Panel fillPanel;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PreferenceDialog()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			LoadPreference();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.mainTabControl = new System.Windows.Forms.TabControl();
			this.operationTabPage = new System.Windows.Forms.TabPage();
			this.threadUIGroupBox = new System.Windows.Forms.GroupBox();
			this.afterAllRadioButton = new System.Windows.Forms.RadioButton();
			this.perLineRadioButton = new System.Windows.Forms.RadioButton();
			this.previewGroupBox = new System.Windows.Forms.GroupBox();
			this.popupGroupBox = new System.Windows.Forms.GroupBox();
			this.threadGroupBox = new System.Windows.Forms.GroupBox();
			this.doubleClickRadioButton = new System.Windows.Forms.RadioButton();
			this.clickRadioButton = new System.Windows.Forms.RadioButton();
			this.connectionTabPage = new System.Windows.Forms.TabPage();
			this.writeProxyGroupBox = new System.Windows.Forms.GroupBox();
			this.writeProxyUALabel = new System.Windows.Forms.Label();
			this.writeProxyURLLabel = new System.Windows.Forms.Label();
			this.writeProxyUATextBox = new System.Windows.Forms.TextBox();
			this.writeProxyURLTextBox = new System.Windows.Forms.TextBox();
			this.readProxyGroupBox = new System.Windows.Forms.GroupBox();
			this.readProxyUALabel = new System.Windows.Forms.Label();
			this.readProxyURLLabel = new System.Windows.Forms.Label();
			this.readProxyUATextBox = new System.Windows.Forms.TextBox();
			this.readProxyURLTextBox = new System.Windows.Forms.TextBox();
			this.boardListGroupBox = new System.Windows.Forms.GroupBox();
			this.boardListTextBox = new System.Windows.Forms.TextBox();
			this.otherTabPage = new System.Windows.Forms.TabPage();
			this.bottomPanel = new System.Windows.Forms.Panel();
			this.cancelButton = new System.Windows.Forms.Button();
			this.okButton = new System.Windows.Forms.Button();
			this.bottomSplitter = new System.Windows.Forms.Splitter();
			this.fillPanel = new System.Windows.Forms.Panel();
			this.mainTabControl.SuspendLayout();
			this.operationTabPage.SuspendLayout();
			this.threadUIGroupBox.SuspendLayout();
			this.threadGroupBox.SuspendLayout();
			this.connectionTabPage.SuspendLayout();
			this.writeProxyGroupBox.SuspendLayout();
			this.readProxyGroupBox.SuspendLayout();
			this.boardListGroupBox.SuspendLayout();
			this.bottomPanel.SuspendLayout();
			this.fillPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainTabControl
			// 
			this.mainTabControl.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.operationTabPage,
																						 this.connectionTabPage,
																						 this.otherTabPage});
			this.mainTabControl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.mainTabControl.Name = "mainTabControl";
			this.mainTabControl.SelectedIndex = 0;
			this.mainTabControl.Size = new System.Drawing.Size(344, 250);
			this.mainTabControl.TabIndex = 0;
			// 
			// operationTabPage
			// 
			this.operationTabPage.Controls.AddRange(new System.Windows.Forms.Control[] {
																						   this.threadUIGroupBox,
																						   this.previewGroupBox,
																						   this.popupGroupBox,
																						   this.threadGroupBox});
			this.operationTabPage.Location = new System.Drawing.Point(4, 21);
			this.operationTabPage.Name = "operationTabPage";
			this.operationTabPage.Size = new System.Drawing.Size(336, 225);
			this.operationTabPage.TabIndex = 0;
			this.operationTabPage.Text = "";
			// 
			// threadUIGroupBox
			// 
			this.threadUIGroupBox.Controls.AddRange(new System.Windows.Forms.Control[] {
																						   this.afterAllRadioButton,
																						   this.perLineRadioButton});
			this.threadUIGroupBox.Location = new System.Drawing.Point(8, 64);
			this.threadUIGroupBox.Name = "threadUIGroupBox";
			this.threadUIGroupBox.Size = new System.Drawing.Size(264, 56);
			this.threadUIGroupBox.TabIndex = 6;
			this.threadUIGroupBox.TabStop = false;
			this.threadUIGroupBox.Text = "XbhXg`XV^C~O";
			// 
			// afterAllRadioButton
			// 
			this.afterAllRadioButton.Checked = true;
			this.afterAllRadioButton.Location = new System.Drawing.Point(120, 16);
			this.afterAllRadioButton.Name = "afterAllRadioButton";
			this.afterAllRadioButton.Size = new System.Drawing.Size(136, 24);
			this.afterAllRadioButton.TabIndex = 1;
			this.afterAllRadioButton.TabStop = true;
			this.afterAllRadioButton.Text = "S^Cg擾";
			// 
			// perLineRadioButton
			// 
			this.perLineRadioButton.Location = new System.Drawing.Point(8, 16);
			this.perLineRadioButton.Name = "perLineRadioButton";
			this.perLineRadioButton.TabIndex = 0;
			this.perLineRadioButton.Text = "1^Cg擾";
			// 
			// previewGroupBox
			// 
			this.previewGroupBox.Location = new System.Drawing.Point(8, 176);
			this.previewGroupBox.Name = "previewGroupBox";
			this.previewGroupBox.Size = new System.Drawing.Size(264, 40);
			this.previewGroupBox.TabIndex = 5;
			this.previewGroupBox.TabStop = false;
			this.previewGroupBox.Text = "摜vr[";
			// 
			// popupGroupBox
			// 
			this.popupGroupBox.Location = new System.Drawing.Point(8, 128);
			this.popupGroupBox.Name = "popupGroupBox";
			this.popupGroupBox.Size = new System.Drawing.Size(264, 40);
			this.popupGroupBox.TabIndex = 4;
			this.popupGroupBox.TabStop = false;
			this.popupGroupBox.Text = "|bvAbv\ʒu";
			// 
			// threadGroupBox
			// 
			this.threadGroupBox.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.doubleClickRadioButton,
																						 this.clickRadioButton});
			this.threadGroupBox.Location = new System.Drawing.Point(8, 8);
			this.threadGroupBox.Name = "threadGroupBox";
			this.threadGroupBox.Size = new System.Drawing.Size(264, 48);
			this.threadGroupBox.TabIndex = 3;
			this.threadGroupBox.TabStop = false;
			this.threadGroupBox.Text = "Xbh擾JnCxg";
			// 
			// doubleClickRadioButton
			// 
			this.doubleClickRadioButton.Location = new System.Drawing.Point(120, 16);
			this.doubleClickRadioButton.Name = "doubleClickRadioButton";
			this.doubleClickRadioButton.Size = new System.Drawing.Size(96, 24);
			this.doubleClickRadioButton.TabIndex = 2;
			this.doubleClickRadioButton.Text = "_uNbN";
			// 
			// clickRadioButton
			// 
			this.clickRadioButton.Checked = true;
			this.clickRadioButton.Location = new System.Drawing.Point(8, 16);
			this.clickRadioButton.Name = "clickRadioButton";
			this.clickRadioButton.Size = new System.Drawing.Size(64, 24);
			this.clickRadioButton.TabIndex = 1;
			this.clickRadioButton.TabStop = true;
			this.clickRadioButton.Text = "NbN";
			// 
			// connectionTabPage
			// 
			this.connectionTabPage.Controls.AddRange(new System.Windows.Forms.Control[] {
																							this.writeProxyGroupBox,
																							this.readProxyGroupBox,
																							this.boardListGroupBox});
			this.connectionTabPage.Location = new System.Drawing.Point(4, 21);
			this.connectionTabPage.Name = "connectionTabPage";
			this.connectionTabPage.Size = new System.Drawing.Size(336, 225);
			this.connectionTabPage.TabIndex = 1;
			this.connectionTabPage.Text = "ʐM";
			// 
			// writeProxyGroupBox
			// 
			this.writeProxyGroupBox.Controls.AddRange(new System.Windows.Forms.Control[] {
																							 this.writeProxyUALabel,
																							 this.writeProxyURLLabel,
																							 this.writeProxyUATextBox,
																							 this.writeProxyURLTextBox});
			this.writeProxyGroupBox.Location = new System.Drawing.Point(8, 144);
			this.writeProxyGroupBox.Name = "writeProxyGroupBox";
			this.writeProxyGroupBox.Size = new System.Drawing.Size(264, 72);
			this.writeProxyGroupBox.TabIndex = 2;
			this.writeProxyGroupBox.TabStop = false;
			this.writeProxyGroupBox.Text = " HTTP Proxy";
			// 
			// writeProxyUALabel
			// 
			this.writeProxyUALabel.Location = new System.Drawing.Point(8, 40);
			this.writeProxyUALabel.Name = "writeProxyUALabel";
			this.writeProxyUALabel.Size = new System.Drawing.Size(72, 16);
			this.writeProxyUALabel.TabIndex = 7;
			this.writeProxyUALabel.Text = "User-Agent:";
			this.writeProxyUALabel.TextAlign = System.Drawing.ContentAlignment.BottomRight;
			// 
			// writeProxyURLLabel
			// 
			this.writeProxyURLLabel.Location = new System.Drawing.Point(8, 16);
			this.writeProxyURLLabel.Name = "writeProxyURLLabel";
			this.writeProxyURLLabel.Size = new System.Drawing.Size(72, 16);
			this.writeProxyURLLabel.TabIndex = 6;
			this.writeProxyURLLabel.Text = "URL:";
			this.writeProxyURLLabel.TextAlign = System.Drawing.ContentAlignment.BottomRight;
			// 
			// writeProxyUATextBox
			// 
			this.writeProxyUATextBox.Location = new System.Drawing.Point(80, 40);
			this.writeProxyUATextBox.Name = "writeProxyUATextBox";
			this.writeProxyUATextBox.Size = new System.Drawing.Size(176, 19);
			this.writeProxyUATextBox.TabIndex = 5;
			this.writeProxyUATextBox.Text = "";
			// 
			// writeProxyURLTextBox
			// 
			this.writeProxyURLTextBox.Location = new System.Drawing.Point(80, 16);
			this.writeProxyURLTextBox.Name = "writeProxyURLTextBox";
			this.writeProxyURLTextBox.Size = new System.Drawing.Size(176, 19);
			this.writeProxyURLTextBox.TabIndex = 4;
			this.writeProxyURLTextBox.Text = "";
			// 
			// readProxyGroupBox
			// 
			this.readProxyGroupBox.Controls.AddRange(new System.Windows.Forms.Control[] {
																							this.readProxyUALabel,
																							this.readProxyURLLabel,
																							this.readProxyUATextBox,
																							this.readProxyURLTextBox});
			this.readProxyGroupBox.Location = new System.Drawing.Point(8, 64);
			this.readProxyGroupBox.Name = "readProxyGroupBox";
			this.readProxyGroupBox.Size = new System.Drawing.Size(264, 72);
			this.readProxyGroupBox.TabIndex = 1;
			this.readProxyGroupBox.TabStop = false;
			this.readProxyGroupBox.Text = "Ǎ HTTP Proxy";
			// 
			// readProxyUALabel
			// 
			this.readProxyUALabel.Location = new System.Drawing.Point(8, 40);
			this.readProxyUALabel.Name = "readProxyUALabel";
			this.readProxyUALabel.Size = new System.Drawing.Size(72, 16);
			this.readProxyUALabel.TabIndex = 3;
			this.readProxyUALabel.Text = "User-Agent:";
			this.readProxyUALabel.TextAlign = System.Drawing.ContentAlignment.BottomRight;
			// 
			// readProxyURLLabel
			// 
			this.readProxyURLLabel.Location = new System.Drawing.Point(8, 16);
			this.readProxyURLLabel.Name = "readProxyURLLabel";
			this.readProxyURLLabel.Size = new System.Drawing.Size(72, 16);
			this.readProxyURLLabel.TabIndex = 2;
			this.readProxyURLLabel.Text = "URL:";
			this.readProxyURLLabel.TextAlign = System.Drawing.ContentAlignment.BottomRight;
			// 
			// readProxyUATextBox
			// 
			this.readProxyUATextBox.Location = new System.Drawing.Point(80, 40);
			this.readProxyUATextBox.Name = "readProxyUATextBox";
			this.readProxyUATextBox.Size = new System.Drawing.Size(176, 19);
			this.readProxyUATextBox.TabIndex = 1;
			this.readProxyUATextBox.Text = "";
			// 
			// readProxyURLTextBox
			// 
			this.readProxyURLTextBox.Location = new System.Drawing.Point(80, 16);
			this.readProxyURLTextBox.Name = "readProxyURLTextBox";
			this.readProxyURLTextBox.Size = new System.Drawing.Size(176, 19);
			this.readProxyURLTextBox.TabIndex = 0;
			this.readProxyURLTextBox.Text = "";
			// 
			// boardListGroupBox
			// 
			this.boardListGroupBox.Controls.AddRange(new System.Windows.Forms.Control[] {
																							this.boardListTextBox});
			this.boardListGroupBox.Location = new System.Drawing.Point(8, 8);
			this.boardListGroupBox.Name = "boardListGroupBox";
			this.boardListGroupBox.Size = new System.Drawing.Size(264, 48);
			this.boardListGroupBox.TabIndex = 0;
			this.boardListGroupBox.TabStop = false;
			this.boardListGroupBox.Text = "XVURL";
			// 
			// boardListTextBox
			// 
			this.boardListTextBox.Location = new System.Drawing.Point(8, 16);
			this.boardListTextBox.Name = "boardListTextBox";
			this.boardListTextBox.Size = new System.Drawing.Size(248, 19);
			this.boardListTextBox.TabIndex = 0;
			this.boardListTextBox.Text = "";
			// 
			// otherTabPage
			// 
			this.otherTabPage.Location = new System.Drawing.Point(4, 21);
			this.otherTabPage.Name = "otherTabPage";
			this.otherTabPage.Size = new System.Drawing.Size(336, 225);
			this.otherTabPage.TabIndex = 2;
			this.otherTabPage.Text = "̑";
			// 
			// bottomPanel
			// 
			this.bottomPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.cancelButton,
																					  this.okButton});
			this.bottomPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.bottomPanel.Location = new System.Drawing.Point(0, 253);
			this.bottomPanel.Name = "bottomPanel";
			this.bottomPanel.Size = new System.Drawing.Size(344, 40);
			this.bottomPanel.TabIndex = 1;
			// 
			// cancelButton
			// 
			this.cancelButton.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.cancelButton.Location = new System.Drawing.Point(179, 8);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 1;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// okButton
			// 
			this.okButton.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.okButton.Location = new System.Drawing.Point(91, 8);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 0;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// bottomSplitter
			// 
			this.bottomSplitter.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.bottomSplitter.Location = new System.Drawing.Point(0, 250);
			this.bottomSplitter.Name = "bottomSplitter";
			this.bottomSplitter.Size = new System.Drawing.Size(344, 3);
			this.bottomSplitter.TabIndex = 2;
			this.bottomSplitter.TabStop = false;
			// 
			// fillPanel
			// 
			this.fillPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.mainTabControl});
			this.fillPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.fillPanel.Name = "fillPanel";
			this.fillPanel.Size = new System.Drawing.Size(344, 250);
			this.fillPanel.TabIndex = 3;
			// 
			// PreferenceDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(344, 293);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.fillPanel,
																		  this.bottomSplitter,
																		  this.bottomPanel});
			this.Name = "PreferenceDialog";
			this.Text = "PreferenceDialog";
			this.mainTabControl.ResumeLayout(false);
			this.operationTabPage.ResumeLayout(false);
			this.threadUIGroupBox.ResumeLayout(false);
			this.threadGroupBox.ResumeLayout(false);
			this.connectionTabPage.ResumeLayout(false);
			this.writeProxyGroupBox.ResumeLayout(false);
			this.readProxyGroupBox.ResumeLayout(false);
			this.boardListGroupBox.ResumeLayout(false);
			this.bottomPanel.ResumeLayout(false);
			this.fillPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// vt@XǂݍŃ_CAO̊eRg[փZbgD
		/// </summary>
		private void LoadPreference() {
			this.boardListTextBox.Text = ZigumoModel.Model.BbsCategoryUrl;
			this.clickRadioButton.Checked = ZigumoModel.Model.IsClickThreadsGetting;
			this.doubleClickRadioButton.Checked = !ZigumoModel.Model.IsClickThreadsGetting;
			this.afterAllRadioButton.Checked = (ZigumoModel.Model.NumberOfThreadsToUpdateUI == 0);
			this.perLineRadioButton.Checked = !(ZigumoModel.Model.NumberOfThreadsToUpdateUI == 0);
		}

		/// <summary>
		/// _CAO̊eRg[lvt@X֏ށD
		/// </summary>
		private void SavePreference() {
			ZigumoModel.Model.BbsCategoryUrl = this.boardListTextBox.Text;
			ZigumoModel.Model.IsClickThreadsGetting = this.clickRadioButton.Checked;
			if (this.afterAllRadioButton.Checked) {
				ZigumoModel.Model.NumberOfThreadsToUpdateUI = 0;
			} else {
				ZigumoModel.Model.NumberOfThreadsToUpdateUI = 1;
			}
		}

		private void okButton_Click(object sender, System.EventArgs e) {
			SavePreference();
			this.Dispose(true);
		}

		private void cancelButton_Click(object sender, System.EventArgs e) {
			this.Dispose(true);
		}

	}
}
