/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: BbsRes.cs,v 1.4 2003/04/25 03:06:50 hoge-taicho Exp $
 * 
 */

using System;
using System.Text.RegularExpressions;

namespace Zigumo.Model
{
	/// <summary>
	/// XNX
	/// </summary>
	public class BbsRes
	{
		/// <summary>
		/// XNo.
		/// </summary>
		private int number;
		/// <summary>
		/// O
		/// </summary>
		private string name;
		/// <summary>
		/// [
		/// </summary>
		private string email;
		/// <summary>
		/// ݓ
		/// </summary>
		private string date;
		/// <summary>
		/// ID
		/// </summary>
		private string id;
		/// <summary>
		/// {
		/// </summary>
		private string text;
		/// <summary>
		/// ̃XLĂXbhւ̎Q
		/// </summary>
		private BbsThread bbsThread;

		/// <summary>
		/// XNo.̃vpeB
		/// </summary>
		public int Number {
			get {
				return number;
			}
			set {
				number = value;
			}
		}
		/// <summary>
		/// ÕvpeB
		/// </summary>
		public string Name {
			get {
				return name;
			}
			set {
				name = value;
			}
		}
		/// <summary>
		/// [̃vpeB
		/// </summary>
		public string Email {
			get {
				return email;
			}
			set {
				email = value;
			}
		}
		/// <summary>
		/// ݓ̃vpeB
		/// </summary>
		public string Date {
			get {
				return date;
			}
			set {
				date = value;
			}
		}
		/// <summary>
		/// ID̃vpeB
		/// </summary>
		public string ID {
			get {
				return id;
			}
			set {
				id = value;
			}
		}
		/// <summary>
		/// {̃vpeB
		/// </summary>
		public string Text {
			get {
				return text;
			}
			set {
				text = value;
			}
		}

		/// <summary>
		/// ̃XLĂXbh̃vpeB
		/// </summary>
		public BbsThread BbsThread {
			get {
				return bbsThread;
			}
			set {
				bbsThread = value;
			}
		}

		public BbsRes(string datText) {
			//f[^̃p[X
			string[] str = Regex.Split(datText, "<>");
			name = "<b>" + str[0] + "</b>";
			email = str[1];
			int index = str[2].IndexOf("ID");
			if(index > 0) {
				date = str[2].Substring(0, index);
				id = str[2].Substring(index);
			} else {
				date = str[2];
				id = "";
			}
			text = str[3];
		}

		/// <summary>
		/// HTML`ɕϊďo
		/// </summary>
		/// <returns></returns>
		public string ConvertToHtml(bool newFlag) {
			ZigumoModel model = ZigumoModel.Model;
			
			//>>99̂悤ȎQƕ\ɂHTML܂͏BA<br>^O͏ȂB
			//{͂PłׂȂ񂾂ǁAK\l̂ʓ|̂ŁA[܂܂B
			//ǂȂlĂBƁAK\͈xRpCƂB
			string text2 = Regex.Replace(text, "<br>", "\r\n");
			text2 = Regex.Replace(text2, "<[^>]*>", "");
			text2 = Regex.Replace(text2, "\r\n", "<br>");

			//Qƍ\̐
			text2 = Regex.Replace(text2, "(&gt;&gt;([0-9]+))", "<a href=\"#$2\">$1</a>");

			//N\̐
			text2 = Regex.Replace(text2, "(http://[a-zA-Z0-9-~/\\.?=&%_]+)", "<a href=\"$1\" target=\"_blank\">$1</a>");

			//VXǂ`FbNev[g؂ւ
			string res = "";
			if(newFlag)
				res = model.ResNewTemplate;
			else
				res = model.ResTemplate;
			res = res.Replace("{NUMBER}", number.ToString());
			if(email == "")
				res = res.Replace("{NAME}", name);
			else
				res = res.Replace("{NAME}", "<a href=\"mailto:" + email + "\">" + name + "</a>");
			res = res.Replace("{DATE}", date);
			res = res.Replace("{ID}", id);
			res = res.Replace("{TEXT}", text2);

			return res;
		}

		/// <summary>
		/// v[eLXg`ŏo
		/// </summary>
		/// <returns></returns>
		public string ConvertToPlainText() {
			ZigumoModel model = ZigumoModel.Model;
			
			string res = model.ResTemplate;
			res = res.Replace("{NUMBER}", number.ToString());
			res = res.Replace("{NAME}", name);
			res = res.Replace("{DATE}", date);
			res = res.Replace("{ID}", id);
			res = res.Replace("{TEXT}", "\r\n" + text);

			//HTML^O
			res = Regex.Replace(res, "<br>", "\r\n");
			res = Regex.Replace(res, "<[^<]*>", "");

			//Qƕ\𕜋A>>
			res = Regex.Replace(res, "&gt;&gt;", ">>");

			return res;
		}

	}//end class
}
