/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: StreamByteReader.cs,v 1.4 2002/12/19 18:08:43 hoge-taicho Exp $
 * 
 */

using System;
using System.IO;
using System.Text;

namespace Zigumo.Network
{
	/// <summary>
	/// eLXgǂݍ݃NX
	/// StreamReaderƂ̈Ⴂ́AoCgǂݍ񂾂WvłƂ
	/// </summary>
	public class StreamByteReader {
		/// <summary>
		/// Xg[
		/// </summary>
		private Stream stream;
		/// <summary>
		/// GR[fBO
		/// </summary>
		private Encoding encoding;
		/// <summary>
		/// obt@
		/// </summary>
		private MemoryStream data = new MemoryStream();
		/// <summary>
		/// ꎞobt@
		/// </summary>
		private byte[] buff = new byte[2048];
		/// <summary>
		/// ꎞobt@̃CfbNX
		/// </summary>
		private int bufferIndex = 0;
		/// <summary>
		/// ꎞobt@̃CfbNX
		/// </summary>
		private int keepBufferIndex = 0;
		/// <summary>
		/// ǂݍ񂾃TCY
		/// </summary>
		private int size = 0;
		/// <summary>
		/// ǂݍ񂾑TCY
		/// </summary>
		private int totalSize = 0;

		/// <summary>
		/// TCỸvpeB
		/// </summary>
		public int Size {
			get {
				return totalSize;
			}
		}
		
		public StreamByteReader() {
		}

		public StreamByteReader(Stream st, Encoding enc) {
			stream = st;
			encoding = enc;
		}


		public string ReadLine() {
			string str = null;

			while(true) {
				
				//ǂݎς݂ŖꍇAlbg[Nf[^擾B
				if(bufferIndex <= 0) {
					size = stream.Read(buff, 0, buff.Length);
					totalSize += size;
					if(size == 0) {//f[^Ȃꍇ
						str = null;
						break;
					}
				}

				bufferIndex = Array.IndexOf(buff, (byte)'\n', bufferIndex, size - bufferIndex);//s擾

				if(bufferIndex != -1) {//s\n݂͑
					data.Write(buff, keepBufferIndex, bufferIndex - keepBufferIndex + 1);		//obt@\n܂ł
					str = encoding.GetString(data.ToArray());				//obt@𕶎ɕϊ
					data = new MemoryStream();								//obt@NA

					bufferIndex++;

					//ꎞobt@ɂ܂f[^͂邩`FbN
					if(bufferIndex >= size) {
						//ꎞobt@Ƀf[^͖ꍇ
						bufferIndex = 0;
					}

					keepBufferIndex = bufferIndex;

					break;
				} else {
					//sꍇ݂͌̃obt@݁AbufferIndex0ɂB
					data.Write(buff, keepBufferIndex, size - keepBufferIndex);//obt@ɏ
					bufferIndex = 0;
					keepBufferIndex = 0;
				}
			}

			return str;
		}
	}
}
