/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ToolTipForm.cs,v 1.4 2002/12/18 17:26:21 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace Zigumo.View
{
	/// <summary>
	/// c[eBbvNX
	/// </summary>
	public class ToolTipForm : System.Windows.Forms.Form {
		/// <summary>
		/// o͕
		/// </summary>
		private string text;
		/// <summary>
		/// o͕isj
		/// </summary>
		private string[] textLines = new string[] {}; 
		/// <summary>
		/// o͕͈
		/// </summary>
		private ArrayList stringRect;
		/// <summary>
		/// o͕
		/// </summary>
		private int width;
		/// <summary>
		/// o͍
		/// </summary>
		private int height;

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ToolTipForm() {
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//c[eBbv̏
			//IuWFNg쐬Ɉx\ĂɏĂB
			//́AtH[JX̖EChE\邽߂
			//OłB\̓tH[JX̖EChE
			//邱ƂłȂ߂킴ƍŏɕ\Ă
			//ڍׂShowWindow APIQƂ̂
			width = 0;
			height = 0;
			ShowWindow();
			Hide();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent() {
			// 
			// ToolTipForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.BackColor = System.Drawing.SystemColors.Info;
			this.ClientSize = new System.Drawing.Size(0, 0);
			this.ControlBox = false;
			this.Enabled = false;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "ToolTipForm";
			this.ShowInTaskbar = false;
			this.TopMost = true;
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.ToolTipForm_Paint);

		}
		#endregion


		/// <summary>
		/// tH[JX̃EChE\邽߂ɂAPI𒼐
		/// ĂяoȂ߁AEChE\pAPI`
		/// </summary>
		[DllImport("user32.dll")]
		public static extern int ShowWindow(IntPtr hwnd, int nCmdShow);

		/// <summary>
		/// ShowWindow(IntPtr hwnd, int nCmdShow);̃I[o[[h
		/// </summary>
		public void ShowWindow() {
			ShowWindow(this.Handle, 8);
		}

		/// <summary>
		/// \Zbg郁\bh
		/// </summary>
		/// <param name="text"></param>
		public void ShowToolTip(string text) {
			this.text = text;

			//̑傫擾邽߂Ƀxgp
			Label label = new Label();
			label.Font = this.Font;
			label.AutoSize = true;
			this.textLines = Regex.Split(text, "\r\n");
			this.stringRect = new ArrayList();
			width = 0;
			height = 0;
			foreach(string str in textLines) {
				label.Text = str;
				this.stringRect.Add(new Rectangle(0, height, label.Width, label.Height));
				if(width < label.Width) width = label.Width;//̍ől߂
				height += label.Height;//vZ
			}

			//Ō̋sA͕\Ȃ悤ɍݒ
			TrimTextLines(textLines, label.Height);
		
			//\ʒuTCYvZ
			this.Width = width + 4;
			this.Height = height + 4;
			Point point = Control.MousePosition;
			this.Left = point.X;
			this.Top = point.Y - height - 16;
			this.WindowState = FormWindowState.Normal;
			ShowWindow();
			Refresh();
		}

		/// <summary>
		/// yCgbZ[W󂯎胁\bh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ToolTipForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			for(int i = 0; i < textLines.Length; i++) {
				Rectangle rc = (Rectangle)this.stringRect[i];
				SolidBrush brush = new SolidBrush(System.Drawing.SystemColors.WindowText);
				StringFormat sf = new StringFormat();
				sf.Alignment    = StringAlignment.Near;
				sf.FormatFlags  = StringFormatFlags.NoWrap;
				Rectangle rect = new Rectangle(rc.X + 2, rc.Y + 2, rc.Width, rc.Height);//EChEƕ̌Ԃ邽߂炷
				e.Graphics.DrawString((string)textLines[i], this.Font, brush, rect, sf);//̕`

				Pen pen = new Pen(brush, 1);
				e.Graphics.DrawRectangle(pen, 0, 0, this.Width - 1, this.Height - 1);//g̕`
			}

		}

		/// <summary>
		/// \̍Ōɂs菜
		/// </summary>
		/// <param name="strLines">̔z</param>
		/// <param name="h">es̍</param>
		private void TrimTextLines(string[] strLines, int h) {
			for(int i = strLines.Length - 1; i > 0; i--) {
				if(strLines[i] == "") {
					height -= h;
				} else {
					break;
				}
			}
		}

	}
}
